'
' SIDSynth Easy Interface to SIDcog
' By Jeff Ledger

    playRate = 50 'Hz
                                     
VAR

byte attack
byte delay
byte sustain
byte release
byte voice
byte volume
word cutoff
word PWM

OBJ
  SID : "SIDCog"

PUB Start(audioR,audioL)

 'Sets up some inital settings which are reasonable pleasant.
   SID.start(audioR,audioL)  
  attack  := 7
  delay   := 9
  sustain := 8
  release := 9
  volume  := 5
  cutoff  := 200
  PWM     := 2048     
  
 

  '' Set some safe defaults
  
  setADSR(0,attack,delay,sustain,release)
  setCUTOFF(cutoff)
  setWAVEFORM(0,1)
  setVOLUME(5)
  setPWM(0,PWM)
                    'Lp,   Bp,   Hp    
  SID.setFilterType(true,false,false)    'Enable lowpass filter

                    'Ch1, Ch2, Ch3      
  SID.setFilterMask(true,false,false)     'Enable filter on the bass channel (channel1)   

PUB setADSR(v,a,d,s,r)

    attack  := a
    delay   := d
    sustain := s
    release := r
    voice   := v
    
    SID.setADSR(voice,attack,delay,sustain,release)

PUB setPWM (ch,p)

    PWM:=p
    SID.setPWM(ch,PWM)

PUB setWaveform(v,type)

    SID.setWaveform(0,type)

PUB setvolume(vol)

    volume:=vol
    SID.setVolume(volume)

PUB setCutoff(cut)

    cutoff:=cut
    SID.SetCutOff(cutoff)
                       
PUB PlayNote(ch,x) | i, note, channel, musicPointer
 
      waitcnt(cnt+(clkfreq/playRate))

      note := x 
      if note                                 
        SID.noteOn(ch,note2freq(note))        
      else
        SID.noteOff(ch)        

PUB SetFilterType(a,b,c)

    SID.setFilterType(a,b,c)

PUB SetFilterMask(ch1,ch2,ch3)

    SID.setFilterMask(ch1,ch2,ch3)
    
PUB SilenceNote
 SID.noteoff(0)
      
PUB note2freq(note) | octave
    octave := note/12
    note -= octave*12 
    return (noteTable[note]>>(8-octave))

DAT
noteTable word 16350, 17320, 18350, 19450, 20600, 21830, 23120, 24500, 25960, 27500, 29140, 30870