CON
  _clkmode = XTAL1|PLL16X
  _xinfreq = 5_000_000

  keyboard = 26

  audioL = 11
  audioR = 24
  LCD_PIN   = 1                                         ' for Parallax 4x20 serial LCD on P0
  LCD_BAUD  = 19_200
  LCD_LINES = 4  
  
VAR

long freqL, freqR
byte l,r,press,screen
byte octave, attack, decay, sustain, release, Low, High, band, tri, saw, sq, noise, volume,wave,filter
word cutoff, pwm
long keystroke, count, channel, note
byte inputmode

OBJ
 
  synth: "SIDSynth"  
  lcd  : "debug_lcd" 
  kb   : "combokeyboard"
  
PUB start 


  wave    := $0001
  note    := 50
  attack  := 5
  decay   := 5
  sustain := 5
  release := 5

  filter  :=%100
  low     := 255
  high    := 0
  band    := 0

  octave  := 24 
  volume  := 5

  cutoff  := 207
  PWM     := 2045
  
  kb.start(keyboard)
  
  'synth.start(audioR,audioL,attack,decay,sustain,release,volume,cutoff,pwm,wave,low,high,band)

   synth.Start(audioR,audioL)

  
  lcd.init(LCD_PIN, LCD_BAUD, LCD_LINES)
  lcd.cls
  lcd.backLight(true) 
  lcd.cursor(0)
  lcd.custom(0, @downarrow)
  lcd.custom(1, @uparrow)
  
  display(9)
  
  waitcnt(clkfreq*1 + cnt)

  getmode
  
pub getmode

   synth.SilenceNote

   display(4)
   
   repeat
 
    press:=kb.getkey

    case press
      49:keyboardtest '1
      50:tonetest     '2
      51:tonemenu     '3
     113:multitones   'q
     195:display(18)  'down
     194:display(4)  'up
           
pub tonemenu  
    display(6)

    repeat
      press := kb.getkey  
      case press
        194: display(6)
        195: display(7)
        203: getmode 'esc 
        111: setoctave  'o
        119: setwaveform 'w
        118: setvolume    'v
        102: setfilters   'f
        97: setattack     'a
        100: setdecay       'd
        115:setsustain       's
        114:setrelease        'r
        113:multitones 'q

pub setoctave

    display(10)
    


    repeat
      press := kb.getkey
      case press
         203: tonemenu             'esc
         108: if octave/12 > 0     'up
                 octave-=12       
         111: if octave/12 < 3     'down
                 octave+=12
      lcd.gotoxy(0,3)
      lcd.decf(octave/12,2)                  
      multitones
    
pub setwaveform

    display(11)
    

    repeat
      lcd.gotoxy(0,3)
      press := kb.getkey
      case press
        203: tonemenu             'esc
        208: wave:=%0000                                           ''F1
             synth.setwaveform(channel,wave)
             lcd.str(string("triangle"))
        209: wave:=%0001
             lcd.str(string("square  "))                                          ''F2
             synth.setwaveform(channel,wave)
        210: wave:=%0010
             lcd.str(string("sawtooth"))                                           ''F3
             synth.setwaveform(channel,wave)
        211: wave:=%0011                                           ''F4
             lcd.str(string("noise   "))
             synth.setwaveform(channel,wave)
      multitones 
                         

pub setvolume

    display(12)
    
    repeat
      press := kb.getkey
      case press
        203: tonemenu             'esc
        118:if volume < 15'' v
                    volume++ 
                    synth.setvolume(volume)
        32:if volume > 0 '' space
                    volume--
                    synth.setvolume(volume)                  

      lcd.gotoxy(0,3)
      lcd.decf(volume,2)
      multitones 

pub setfilters

     display(13)
     
     
     repeat
        lcd.gotoxy(0,3)
        press:=kb.getkey
        case press
          113:multitones 'q  
          203: tonemenu 
          217:filter:=%100
              synth.setFilterType(255,0,0)  
              lcd.str(string("low "))             ''F10                  
          218:filter:=%010
              synth.setFilterType(0,255,0)
              lcd.str(string("high"))             ''F11                 
          219:filter:=%001
              synth.setFilterType(0,0,255) 
              lcd.str(string("band"))             ''F12

        multitones 
                 
pub setattack

    display (14)
    
    repeat
      lcd.gotoxy(1,3)
      press:=kb.getkey
      case press
        113:multitones 'q   
        203:tonemenu 'esc
        113:multitones 'q
        97:if attack < 15 ''a
            attack++
            synth.setadsr(channel,attack,decay,sustain,release)
        122:if attack > 0 ''z
             attack--
             synth.setadsr(channel,attack,decay,sustain,release)
      lcd.decf(attack,2)


    
pub setdecay

    display(15)

    repeat  
      lcd.gotoxy(1,3)
      press:=kb.getkey
      case press
        113:multitones 'q 
        203:tonemenu
        113:multitones
        100:if decay < 15     '' d key
                    decay++ 
                    synth.setadsr(channel,attack,decay,sustain,release)
        99:if decay > 0 '' c key
                    decay-- 
                    synth.setadsr(channel,attack,decay,sustain,release) 
      lcd.decf(decay,2)



pub setrelease


    display(17)

    repeat
      lcd.gotoxy(1,3)
      press:=kb.getkey
      case press
        113:multitones 'q  
        203:tonemenu
        113:multitones
        114:if release < 15'' r key
                    release++ 
                    synth.setadsr(channel,attack,decay,sustain,release)
        102:if release > 0 '' 102
                    release--
                    synth.setadsr(channel,attack,decay,sustain,release) 
      lcd.decf(release,2)











pub setsustain

    display(16)

    repeat
      lcd.gotoxy(1,3)
      press:=kb.getkey
      case press
        113:multitones 'q  
        203:tonemenu
        113:multitones
        115:if sustain < 15'' s key
                    sustain++ 
                    synth.setadsr(channel,attack,decay,sustain,release)
        120:if sustain > 0 '' x key
                    sustain--
                    synth.setadsr(channel,attack,decay,sustain,release) 
      lcd.decf(sustain,2)
        
pub keyboardtest

  display(8)

  repeat      'c l
    press:=kb.getkey
    lcd.gotoxy(4,3)
    lcd.hex(press,3)
    lcd.gotoxy(14,3)
    lcd.decf(press,3)
    if press == 203
      getmode

pub display(mode)

  lcd.cls
  
  case mode
    0:  
     lcd.gotoxy(0, 0)
     lcd.Str(string(".ready 0-128_000_000"))

    1:lcd.gotoxy(0, 1)
      lcd.str(string(".playing........"))
      lcd.dec(freqL)
      lcd.str(string(" ,"))
      lcd.dec(freqR) 

    2:lcd.gotoxy(0, 2)
      lcd.str(string(".l ="))
      lcd.dec(freql)
      lcd.str(string("  "))

    3:lcd.gotoxy(0, 3)
      lcd.str(string(".r ="))
      lcd.dec(freqR)
      lcd.str(string("  "))

    4:lcd.gotoxy(0,0)
      lcd.str(string(".select a mode"))
      lcd.gotoxy(0,1)
      lcd.str(string("1 = keyboard test"))
      lcd.gotoxy(0,2)
      lcd.str(string("2 = tone test"))
      lcd.gotoxy(0,3)
      lcd.str(string("3 = tone menu"))
      lcd.gotoxy(19,3)
      lcd.putc(0)    

    18:lcd.gotoxy(0,0)
       lcd.str(string("q = multitone"))
       lcd.gotoxy(19,3)
       lcd.putc(1)




    
    5:lcd.gotoxy(0, 0)
      lcd.str(string(".tone test / press any key to play tone / press esc to quit"))

    6:lcd.gotoxy(0,0)
      lcd.str(string("o octave",13))
      lcd.str(string("w waveform",13))
      lcd.str(string("v volume",13))
      lcd.str(string("f filters"))
      lcd.gotoxy(19,3)
      lcd.putc(0)
      
    7:lcd.cls
      lcd.gotoxy(0,0)
      lcd.str(string("a attack",13))
      lcd.str(string("d decay",13))
      lcd.str(string("s sustain",13))
      lcd.str(string("r release"))
      lcd.gotoxy(19,3)
      lcd.putc(1)                               

    8:lcd.gotoxy(0, 0)
      lcd.str(string(".keyboard test"))
      lcd.gotoxy(0,3)
      lcd.str(string("hex:"))
      lcd.gotoxy(10,3)
      lcd.str(string("dec:"))

    9:lcd.gotoxy(0,0)
      lcd.str(string(".welcome"))
      lcd.gotoxy(0,2)
      lcd.str(string(".booting.synth...."))

    10:lcd.gotoxy(0,0)
       lcd.str(string("octave     o/l  "))
       lcd.gotoxy(0,2)
       lcd.str(string("new octave"))
       lcd.gotoxy(0,1)
       lcd.decf(octave/12,2)
       
    11:lcd.gotoxy(0,0)
       lcd.str(string("waveform     F1-F4  "))  
       lcd.gotoxy(0,2)
       lcd.str(string("new waveform"))
       lcd.gotoxy(0,1)
       if wave==%0000
         lcd.str(string("triangle"))
       if wave==%0001
         lcd.str(string("square  ")) 
       if wave==%0010
         lcd.str(string("sawtooth")) 
       if wave==%0011
         lcd.str(string("noise   "))  


      
    12:lcd.gotoxy(0,0)
      lcd.str(string("volume      v/space "))
      lcd.gotoxy(0,2)
      lcd.str(string("new volume"))
      lcd.gotoxy(0,1)
      lcd.decf(volume,2)

    13:lcd.gotoxy(0,0)
      lcd.str(string("filter      F10-12  "))
      lcd.gotoxy(0,2)
      lcd.str(string("new filter"))
      lcd.gotoxy(0,1)
      if filter==%100
         lcd.str(string("low"))
      if filter==%010
         lcd.str(string("high"))
      if filter==%001
         lcd.str(string("band"))
      
    14:lcd.gotoxy(0,0)
      lcd.str(string("attack       A/Z    "))
      lcd.gotoxy(1,1)
      lcd.decf(attack,2)
      lcd.gotoxy(0,2)
      lcd.str(string("new attack"))

    15:lcd.gotoxy(0,0)
      lcd.str(string("decay       D/C     "))
      lcd.gotoxy(1,1)
      lcd.decf(decay,2)
      lcd.gotoxy(0,2)
      lcd.str(string("new decay"))

    16:lcd.gotoxy(0,0)
      lcd.str(string("sustain     S/X     "))
      lcd.gotoxy(1,1)
      lcd.decf(sustain,2)
      lcd.gotoxy(0,2)
      lcd.str(string("new sustain"))

    17:lcd.gotoxy(0,0)
      lcd.str(string("release     R/F     "))
      lcd.gotoxy(1,1)
      lcd.decf(release,2)
      lcd.gotoxy(0,2)
      lcd.str(string("new release"))  
    
  waitcnt(clkfreq*1 + cnt) 

{
pub getvals  
    'position in case echo is on

    freqL := serial.DecIn                                  ' read decimal value
    showstate(2)

    showstate(0)

    serial.Position(13, 3)
    freqR := serial.DecIn
    showstate(3)


pub clearvals

    serial.Position(13, 2)
    serial.Str(string("                          "))
    serial.Position(13, 3)
    serial.Str(string("                          ")) 
    waitcnt(clkfreq*1 + cnt)                             } 
                                                                        
pub tonetest

    
  display(5)

  repeat 
    press:=kb.getkey  
    case press
      203:getmode
      other:playtone
    
pub playtone

    synth.playnote(channel,note+octave)

pub multitones

   synth.SilenceNote
   repeat 8
    synth.playnote(0,note+octave)
    waitcnt(clkfreq/4+cnt)
    synth.silencenote
   


    
pub later
  repeat

      press:=kb.getkey

      case press
          203: getmode
          223: display(6)
          223: display(6)
          
          212:'f5
                 if inputmode == 0
                    inputmode := 1
                 else
                    inputmode := 0
          113:'q
                 note:=60
          50:'2
                 note:=61
          119:'w
                 note:=62
          51:'3
                 note:=63
          101:'e
                 note:=64
          114:'r
                 note:=65
          53:  '5
                 note:=66
          116: 't
                 note:=67
          54:  '6
                 note:=68
          121: 'y
                 note:=69
          55:  '7
                 note:=70
          117: 'u
                 note:=71
          105: 'i
                 note:=72
          57: '2
                 note:=73
          111: 'o
                 note:=74
          48:  '0
                 note:=75
          112: 'p
                 note:=76
          ' Set Waveforms
          208: ''F1
                 synth.setwaveform(channel,0)
                 saw:=0
                 sq:=0
                 noise:=0
                 tri:=1
          209: ''F2
                 synth.setwaveform(channel,1)
                 saw:=1
                 sq:=0
                 noise:=0
                 tri:=0
          210: ''F3
                 synth.setwaveform(channel,2)
                 saw:=0
                 sq:=1
                 noise:=0
                 tri:=0
          211: ''F4
                 synth.setwaveform(channel,3)
                 saw:=0
                 sq:=0
                 noise:=1
                 tri:=0       
               ' Set Filters
          217: ''F10
                 !low
                 synth.setFilterType(low,high,band)
          218: ''F11
                 !high
                 synth.setFilterType(low,high,band)
          219: ''F12
                 !band
                 synth.setFilterType(low,high,band)
          ' ADSR Envelope Setting
          97:    if attack < 15 ''a
                     attack++
                     synth.setadsr(channel,attack,decay,sustain,release)
          122:   if attack > 0 ''z
                     attack--
                     synth.setadsr(channel,attack,decay,sustain,release)
          115:   if decay < 15 ''s
                     decay++
                     synth.setadsr(channel,attack,decay,sustain,release)
          120:   if decay > 0  ''x
                     decay--
                     synth.setadsr(channel,attack,decay,sustain,release)
          100:   if sustain < 15 ''d
                     sustain++
                     synth.setadsr(channel,attack,decay,sustain,release)
          99:    if sustain > 0   ''c
                     sustain--
                     synth.setadsr(channel,attack,decay,sustain,release)
          102:   if release < 15 ''f
                    release++
                    synth.setadsr(channel,attack,decay,sustain,release)
          118:   if release > 0  ''v
                    release--
                    synth.setadsr(channel,attack,decay,sustain,release)
          ' Set octave
          192:   if octave/12 > 0''Curcor Right
                    octave-=12
          193:   if octave/12 < 3''Curcor Left
                    octave+=12
          ' Set volume
          194:   if volume < 15'' Cursor key UP
                    volume++
                    synth.setvolume(volume)
          195:   if volume > 0 '' Cursor key DOWN
                    volume--
                    synth.setvolume(volume)
          ' Set Cutoff
          198:   if cutoff < 2047'' PageUp
                    cutoff+=10
                    synth.setcutoff(cutoff)
          199:   if cutoff > 7'' PageUp
                    cutoff-=10
                    synth.setcutoff(cutoff)
           ' Set PWM
          196:   if PWM < 4095'' Home
                    PWM+=10
                    synth.setPWM(channel,PWM)
          197:   if PWM > 5 '' End
                    PWM-=10
                    synth.setPWM(channel,PWM)


      synth.playnote(channel,note+octave)
      note:=0
      press:=0
      synth.SilenceNote

dat

downarrow       byte  $04,$04,$04,$04,$11,$0A,$04,$00
uparrow      byte $04,$0A,$11,$04,$04,$04,$04,$00

welcome byte "Welcome to the propsynth",13,0
     